<template>
  <div class="trends-page">
    <div class="tway-title-hero" />
    <div :class="mobile ? 'pt-4' : ''" class="trends">
      <v-container fluid>
        <v-layout row>
          <v-flex class="px-3" xs12 md4>
            <div
              :class="mobile ? 'text-center' : ''"
              class="tway-headline-3 mb-3"
            >
              Actualidad
            </div>
            <div
              v-for="(current, n) in posts.current.slice(
                0,
                Math.floor(posts.current.length / 2)
              )"
              :key="current.id"
            >
              <card
                v-if="
                  current.flag == 'SMALL' && current.sourceType != 'GETABSTRACT'
                "
                :left="n % 2 !== 0"
                class="mb-5"
                :post="current"
              />
              <image-trend-post-card
                v-if="
                  current.flag != 'SMALL' && current.sourceType != 'GETABSTRACT'
                "
                class="mb-5"
                :post="current"
              />
              <horizontal-trend-post-card-getabstract
                v-if="
                  current.flag == 'SMALL' && current.sourceType == 'GETABSTRACT'
                "
                :left="n % 2 !== 0"
                class="mb-5"
                :post="current.source"
              />
              <image-trend-post-card-getabstract
                v-if="
                  current.flag != 'SMALL' && current.sourceType == 'GETABSTRACT'
                "
                class="mb-5"
                :post="current.source"
              />
            </div>
          </v-flex>
          <v-flex class="px-3" xs12 md4>
            <div class="tway-headline-3 white--text mb-3">.</div>

            <div
              v-for="(current, n) in posts.current.slice(
                Math.floor(posts.current.length / 2),
                posts.current.length + 1
              )"
              :key="current.id"
            >
              <card
                v-if="
                  current.flag == 'SMALL' && current.sourceType != 'GETABSTRACT'
                "
                :left="n % 2 !== 0"
                class="mb-5"
                :post="current"
              />
              <image-trend-post-card
                v-if="
                  current.flag != 'SMALL' && current.sourceType != 'GETABSTRACT'
                "
                class="mb-5"
                :post="current"
              />
              <horizontal-trend-post-card-getabstract
                v-if="
                  current.flag == 'SMALL' && current.sourceType == 'GETABSTRACT'
                "
                :left="n % 2 !== 0"
                class="mb-5"
                :post="current.source"
              />
              <image-trend-post-card-getabstract
                v-if="
                  current.flag != 'SMALL' && current.sourceType == 'GETABSTRACT'
                "
                class="mb-5"
                :post="current.source"
              />
            </div>
          </v-flex>
          <v-flex class="px-3" :class="mobile ? 'mb-15' : ''" xs12 md4>
            <div
              :class="mobile ? 'text-center' : ''"
              class="tway-headline-3 mb-3"
            >
              Opinión
            </div>
            <div v-for="(current, n) in posts.opinion" :key="current.id">
              <card
                v-if="
                  current.flag == 'SMALL' && current.sourceType != 'GETABSTRACT'
                "
                :left="n % 2 !== 0"
                class="mb-5"
                :post="current"
              />
              <image-trend-post-card
                v-if="
                  current.flag != 'SMALL' && current.sourceType != 'GETABSTRACT'
                "
                class="mb-5"
                :post="current"
              />
              <horizontal-trend-post-card-getabstract
                v-if="
                  current.flag == 'SMALL' && current.sourceType == 'GETABSTRACT'
                "
                :left="n % 2 !== 0"
                class="mb-5"
                :post="current.source"
              />
              <image-trend-post-card-getabstract
                v-if="
                  current.flag != 'SMALL' && current.sourceType == 'GETABSTRACT'
                "
                class="mb-5"
                :post="current.source"
              />
            </div>
          </v-flex>
        </v-layout>
      </v-container>
    </div>
    <div class="tway-waves tway-waves-white-up" />
    <div class="quote">
      <v-container fluid class="text-center">
        <v-btn
          style="
            height: 36px;
            font-weight: bold;
            font-size: 14px;
            line-height: 16px;
            letter-spacing: 0.1em;
          "
          :to="{ name: 'trends' }"
          color="tway-violet"
          class="white--text roboto"
          x-large
          rounded
        >
          ir a tendencias
        </v-btn>
      </v-container>
    </div>
  </div>
</template>

<script>
import HorizontalTrendPostCard from "@/components/trends/trends/HorizontalTrendPostCard";
import ImageTrendPostCard from "@/components/trends/trends/ImageTrendPostCard";

import TrendService from "@/services/trendService";
import HorizontalTrendPostCardGetAbstract from "@/components/trends/trends/HorizontalTrendPostCardGetAbstract";
import ImageTrendPostCardGetAbstract from "@/components/trends/trends/ImageTrendPostCardGetAbstract";

export default {
  name: "HomeTrends",

  components: {
    card: HorizontalTrendPostCard,
    "horizontal-trend-post-card-getabstract":
      HorizontalTrendPostCardGetAbstract,
    "image-trend-post-card-getabstract": ImageTrendPostCardGetAbstract,
    ImageTrendPostCard,
  },

  data() {
    return {
      posts: {
        current: [],
        opinion: [],
        statistics: [],
        studies: [],
      },
    };
  },

  created() {
    TrendService.getTrends()
      .then((trends) => {
        this.posts.opinion = trends.filter((e) => e.category == "COLUMN");
        this.posts.current = trends.filter((e) => e.category != "COLUMN");

        this.posts.current.sort((a, b) => {
          let d1 = new Date(a.createdOn);
          let d2 = new Date(b.createdOn);

          return d2 > d1 ? 1 : -1;
        });
        this.posts.opinion.sort((a, b) => {
          let d1 = new Date(a.createdOn);
          let d2 = new Date(b.createdOn);

          return d2 > d1 ? 1 : -1;
        });
      })
      .catch((err) => {
        this.$log.error(err);
      });
  },

  methods: {},

  computed: {
    mobile() {
      return this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs;
    },
  },
};
</script>
